package org.jdtaus.core.container.mojo;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on jdtaus-container-mojo.<br/> Call <pre>  mvn jdtaus-container-mojo:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Sat Mar 31 08:11:48 CEST 2012
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.5.1)
 * @goal help
 * @requiresProject false
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.jdtaus.mojo:jdtaus-container-mojo:3.9", 0 );
        append( sb, "", 0 );

        append( sb, "jDTAUS Core Container Mojo", 0 );
        append( sb, "Source generator for the container model.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 10 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "clean-sources".equals( goal ) )
        {
            append( sb, "jdtaus-container-mojo:clean-sources", 0 );
            append( sb, "Mojo to cleanup source files (e.g. remove trailing spaces).", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classPathElementsExcludeRegexp", 2 );
                append( sb, "A regular expression used for excluding elements from the runtime classpath elements. By default no elements will be excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "encoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing sources. By default the system\'s default encoding will be used.", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "Language to be used for javadoc comments. By default the system\'s default locale will be used.", 3 );
                append( sb, "", 0 );

                append( sb, "spacesPerIndentationLevel (Default: 4)", 2 );
                append( sb, "Number of spaces to use per indentation level.", 3 );
                append( sb, "", 0 );

                append( sb, "testClassPathElementsExcludeRegexp", 2 );
                append( sb, "A regular expression used for excluding elements from the test classpath elements. By default no elements will be excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "testMode (Default: false)", 2 );
                append( sb, "Flag indicating test mode. In test mode generated sources will be printed to the console and no files will be written.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "jdtaus-container-mojo:help", 0 );
            append( sb, "Display help information on jdtaus-container-mojo.\nCall\n\u00a0\u00a0mvn\u00a0jdtaus-container-mojo:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "java-commit".equals( goal ) )
        {
            append( sb, "jdtaus-container-mojo:java-commit", 0 );
            append( sb, "Mojo to commit container meta-data to compiled java classes.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classPathElementsExcludeRegexp", 2 );
                append( sb, "A regular expression used for excluding elements from the runtime classpath elements. By default no elements will be excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "constructorsEndingMarker (Default: //------------------------------------------------------------Constructors--)", 2 );
                append( sb, "The string marking the ending line up to where constructor code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "constructorsStartingMarker (Default: //--Constructors------------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting constructor code.", 3 );
                append( sb, "", 0 );

                append( sb, "dependenciesEndingMarker (Default: //------------------------------------------------------------Dependencies--)", 2 );
                append( sb, "The string marking the ending line up to where dependency code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "dependenciesStartingMarker (Default: //--Dependencies------------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting dependency code.", 3 );
                append( sb, "", 0 );

                append( sb, "encoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing sources. By default the system\'s default encoding will be used.", 3 );
                append( sb, "", 0 );

                append( sb, "implementationsEndingMarker (Default: //----------------------------------------------------------Implementation--)", 2 );
                append( sb, "The string marking the ending line up to where implementation code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "implementationsStartingMarker (Default: //--Implementation----------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting implementation code.", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "Language to be used for javadoc comments. By default the system\'s default locale will be used.", 3 );
                append( sb, "", 0 );

                append( sb, "messagesEndingMarker (Default: //----------------------------------------------------------------Messages--)", 2 );
                append( sb, "The string marking the ending line up to where implementation message code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "messagesStartingMarker (Default: //--Messages----------------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting implementation message code.", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "The name of the module to process.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory", 2 );
                append( sb, "Output directory.", 3 );
                append( sb, "", 0 );

                append( sb, "propertiesEndingMarker (Default: //--------------------------------------------------------------Properties--)", 2 );
                append( sb, "The string marking the ending line up to where implementation property code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "propertiesStartingMarker (Default: //--Properties--------------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting implementation property code.", 3 );
                append( sb, "", 0 );

                append( sb, "sourceRoot (Default: ${basedir}/src/main/java)", 2 );
                append( sb, "Source root to create new source files in.", 3 );
                append( sb, "", 0 );

                append( sb, "spacesPerIndentationLevel (Default: 4)", 2 );
                append( sb, "Number of spaces to use per indentation level.", 3 );
                append( sb, "", 0 );

                append( sb, "specificationsEndingMarker (Default: //-----------------------------------------------------------Specification--)", 2 );
                append( sb, "The string marking the ending line up to where specification code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "specificationsStartingMarker (Default: //--Specification-----------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting specification code.", 3 );
                append( sb, "", 0 );

                append( sb, "targetIde (Default: netbeans)", 2 );
                append( sb, "Specifies the target editor used for editing sourcefiles. Used for e.g. generating folding markers specific to IDE editors. Currently available options are none and netbeans.", 3 );
                append( sb, "", 0 );

                append( sb, "testClassPathElementsExcludeRegexp", 2 );
                append( sb, "A regular expression used for excluding elements from the test classpath elements. By default no elements will be excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "testMode (Default: false)", 2 );
                append( sb, "Flag indicating test mode. In test mode generated sources will be printed to the console and no files will be written.", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleName (Default: ${project.name} Tests)", 2 );
                append( sb, "The name of the test module to process.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "java-commit-tests".equals( goal ) )
        {
            append( sb, "jdtaus-container-mojo:java-commit-tests", 0 );
            append( sb, "Mojo to commit container meta-data to compiled java test classes.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classPathElementsExcludeRegexp", 2 );
                append( sb, "A regular expression used for excluding elements from the runtime classpath elements. By default no elements will be excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "constructorsEndingMarker (Default: //------------------------------------------------------------Constructors--)", 2 );
                append( sb, "The string marking the ending line up to where constructor code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "constructorsStartingMarker (Default: //--Constructors------------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting constructor code.", 3 );
                append( sb, "", 0 );

                append( sb, "dependenciesEndingMarker (Default: //------------------------------------------------------------Dependencies--)", 2 );
                append( sb, "The string marking the ending line up to where dependency code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "dependenciesStartingMarker (Default: //--Dependencies------------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting dependency code.", 3 );
                append( sb, "", 0 );

                append( sb, "encoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing sources. By default the system\'s default encoding will be used.", 3 );
                append( sb, "", 0 );

                append( sb, "implementationsEndingMarker (Default: //----------------------------------------------------------Implementation--)", 2 );
                append( sb, "The string marking the ending line up to where implementation code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "implementationsStartingMarker (Default: //--Implementation----------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting implementation code.", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "Language to be used for javadoc comments. By default the system\'s default locale will be used.", 3 );
                append( sb, "", 0 );

                append( sb, "messagesEndingMarker (Default: //----------------------------------------------------------------Messages--)", 2 );
                append( sb, "The string marking the ending line up to where implementation message code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "messagesStartingMarker (Default: //--Messages----------------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting implementation message code.", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "The name of the module to process.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory", 2 );
                append( sb, "Output directory.", 3 );
                append( sb, "", 0 );

                append( sb, "propertiesEndingMarker (Default: //--------------------------------------------------------------Properties--)", 2 );
                append( sb, "The string marking the ending line up to where implementation property code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "propertiesStartingMarker (Default: //--Properties--------------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting implementation property code.", 3 );
                append( sb, "", 0 );

                append( sb, "sourceRoot (Default: ${basedir}/src/main/java)", 2 );
                append( sb, "Source root to create new source files in.", 3 );
                append( sb, "", 0 );

                append( sb, "spacesPerIndentationLevel (Default: 4)", 2 );
                append( sb, "Number of spaces to use per indentation level.", 3 );
                append( sb, "", 0 );

                append( sb, "specificationsEndingMarker (Default: //-----------------------------------------------------------Specification--)", 2 );
                append( sb, "The string marking the ending line up to where specification code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "specificationsStartingMarker (Default: //--Specification-----------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting specification code.", 3 );
                append( sb, "", 0 );

                append( sb, "targetIde (Default: netbeans)", 2 );
                append( sb, "Specifies the target editor used for editing sourcefiles. Used for e.g. generating folding markers specific to IDE editors. Currently available options are none and netbeans.", 3 );
                append( sb, "", 0 );

                append( sb, "testClassPathElementsExcludeRegexp", 2 );
                append( sb, "A regular expression used for excluding elements from the test classpath elements. By default no elements will be excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "testMode (Default: false)", 2 );
                append( sb, "Flag indicating test mode. In test mode generated sources will be printed to the console and no files will be written.", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleName (Default: ${project.name} Tests)", 2 );
                append( sb, "The name of the test module to process.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "java-container".equals( goal ) )
        {
            append( sb, "jdtaus-container-mojo:java-container", 0 );
            append( sb, "Mojo to generate java code.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classPathElementsExcludeRegexp", 2 );
                append( sb, "A regular expression used for excluding elements from the runtime classpath elements. By default no elements will be excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "constructorsEndingMarker (Default: //------------------------------------------------------------Constructors--)", 2 );
                append( sb, "The string marking the ending line up to where constructor code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "constructorsStartingMarker (Default: //--Constructors------------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting constructor code.", 3 );
                append( sb, "", 0 );

                append( sb, "dependenciesEndingMarker (Default: //------------------------------------------------------------Dependencies--)", 2 );
                append( sb, "The string marking the ending line up to where dependency code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "dependenciesStartingMarker (Default: //--Dependencies------------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting dependency code.", 3 );
                append( sb, "", 0 );

                append( sb, "encoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing sources. By default the system\'s default encoding will be used.", 3 );
                append( sb, "", 0 );

                append( sb, "implementationsEndingMarker (Default: //----------------------------------------------------------Implementation--)", 2 );
                append( sb, "The string marking the ending line up to where implementation code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "implementationsStartingMarker (Default: //--Implementation----------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting implementation code.", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "Language to be used for javadoc comments. By default the system\'s default locale will be used.", 3 );
                append( sb, "", 0 );

                append( sb, "messagesEndingMarker (Default: //----------------------------------------------------------------Messages--)", 2 );
                append( sb, "The string marking the ending line up to where implementation message code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "messagesStartingMarker (Default: //--Messages----------------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting implementation message code.", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "The name of the module to process.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory", 2 );
                append( sb, "Output directory.", 3 );
                append( sb, "", 0 );

                append( sb, "propertiesEndingMarker (Default: //--------------------------------------------------------------Properties--)", 2 );
                append( sb, "The string marking the ending line up to where implementation property code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "propertiesStartingMarker (Default: //--Properties--------------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting implementation property code.", 3 );
                append( sb, "", 0 );

                append( sb, "sourceRoot (Default: ${basedir}/src/main/java)", 2 );
                append( sb, "Source root to create new source files in.", 3 );
                append( sb, "", 0 );

                append( sb, "spacesPerIndentationLevel (Default: 4)", 2 );
                append( sb, "Number of spaces to use per indentation level.", 3 );
                append( sb, "", 0 );

                append( sb, "specificationsEndingMarker (Default: //-----------------------------------------------------------Specification--)", 2 );
                append( sb, "The string marking the ending line up to where specification code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "specificationsStartingMarker (Default: //--Specification-----------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting specification code.", 3 );
                append( sb, "", 0 );

                append( sb, "targetIde (Default: netbeans)", 2 );
                append( sb, "Specifies the target editor used for editing sourcefiles. Used for e.g. generating folding markers specific to IDE editors. Currently available options are none and netbeans.", 3 );
                append( sb, "", 0 );

                append( sb, "testClassPathElementsExcludeRegexp", 2 );
                append( sb, "A regular expression used for excluding elements from the test classpath elements. By default no elements will be excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "testMode (Default: false)", 2 );
                append( sb, "Flag indicating test mode. In test mode generated sources will be printed to the console and no files will be written.", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleName (Default: ${project.name} Tests)", 2 );
                append( sb, "The name of the test module to process.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "java-container-tests".equals( goal ) )
        {
            append( sb, "jdtaus-container-mojo:java-container-tests", 0 );
            append( sb, "Mojo to generate test java code.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classPathElementsExcludeRegexp", 2 );
                append( sb, "A regular expression used for excluding elements from the runtime classpath elements. By default no elements will be excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "constructorsEndingMarker (Default: //------------------------------------------------------------Constructors--)", 2 );
                append( sb, "The string marking the ending line up to where constructor code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "constructorsStartingMarker (Default: //--Constructors------------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting constructor code.", 3 );
                append( sb, "", 0 );

                append( sb, "dependenciesEndingMarker (Default: //------------------------------------------------------------Dependencies--)", 2 );
                append( sb, "The string marking the ending line up to where dependency code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "dependenciesStartingMarker (Default: //--Dependencies------------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting dependency code.", 3 );
                append( sb, "", 0 );

                append( sb, "encoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing sources. By default the system\'s default encoding will be used.", 3 );
                append( sb, "", 0 );

                append( sb, "implementationsEndingMarker (Default: //----------------------------------------------------------Implementation--)", 2 );
                append( sb, "The string marking the ending line up to where implementation code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "implementationsStartingMarker (Default: //--Implementation----------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting implementation code.", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "Language to be used for javadoc comments. By default the system\'s default locale will be used.", 3 );
                append( sb, "", 0 );

                append( sb, "messagesEndingMarker (Default: //----------------------------------------------------------------Messages--)", 2 );
                append( sb, "The string marking the ending line up to where implementation message code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "messagesStartingMarker (Default: //--Messages----------------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting implementation message code.", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "The name of the module to process.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory", 2 );
                append( sb, "Output directory.", 3 );
                append( sb, "", 0 );

                append( sb, "propertiesEndingMarker (Default: //--------------------------------------------------------------Properties--)", 2 );
                append( sb, "The string marking the ending line up to where implementation property code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "propertiesStartingMarker (Default: //--Properties--------------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting implementation property code.", 3 );
                append( sb, "", 0 );

                append( sb, "sourceRoot (Default: ${basedir}/src/main/java)", 2 );
                append( sb, "Source root to create new source files in.", 3 );
                append( sb, "", 0 );

                append( sb, "spacesPerIndentationLevel (Default: 4)", 2 );
                append( sb, "Number of spaces to use per indentation level.", 3 );
                append( sb, "", 0 );

                append( sb, "specificationsEndingMarker (Default: //-----------------------------------------------------------Specification--)", 2 );
                append( sb, "The string marking the ending line up to where specification code should be inserted.", 3 );
                append( sb, "", 0 );

                append( sb, "specificationsStartingMarker (Default: //--Specification-----------------------------------------------------------)", 2 );
                append( sb, "The string marking the starting line where to start inserting specification code.", 3 );
                append( sb, "", 0 );

                append( sb, "targetIde (Default: netbeans)", 2 );
                append( sb, "Specifies the target editor used for editing sourcefiles. Used for e.g. generating folding markers specific to IDE editors. Currently available options are none and netbeans.", 3 );
                append( sb, "", 0 );

                append( sb, "testClassPathElementsExcludeRegexp", 2 );
                append( sb, "A regular expression used for excluding elements from the test classpath elements. By default no elements will be excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "testMode (Default: false)", 2 );
                append( sb, "Flag indicating test mode. In test mode generated sources will be printed to the console and no files will be written.", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleName (Default: ${project.name} Tests)", 2 );
                append( sb, "The name of the test module to process.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "report".equals( goal ) )
        {
            append( sb, "jdtaus-container-mojo:report", 0 );
            append( sb, "Generates a report for the artifact\'s container metadata.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "buildOutputDirectory", 2 );
                append( sb, "Build output directory.", 3 );
                append( sb, "", 0 );

                append( sb, "javadocDirectory (Default: apidocs)", 2 );
                append( sb, "Location of the javadoc documentation to link to. Keep this in sync with the javadoc plugin.", 3 );
                append( sb, "", 0 );

                append( sb, "linkJavadoc (Default: true)", 2 );
                append( sb, "true to generate links to javadoc documentation. false to not generate links to javadoc documentation.", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "Name of the module to generate a report for.", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.reporting.outputDirectory})", 2 );
                append( sb, "The output directory for the report. Note that this parameter is only evaluated if the goal is run directly from the command line. If the goal is run indirectly as part of a site generation, the output directory configured in Maven Site Plugin is used instead.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "spring-descriptor".equals( goal ) )
        {
            append( sb, "jdtaus-container-mojo:spring-descriptor", 0 );
            append( sb, "Mojo to generate a spring beans descriptor with corresponding support classes from a project.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classPathElementsExcludeRegexp", 2 );
                append( sb, "A regular expression used for excluding elements from the runtime classpath elements. By default no elements will be excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "encoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing sources. By default the system\'s default encoding will be used.", 3 );
                append( sb, "", 0 );

                append( sb, "factoryBean", 2 );
                append( sb, "Class name of the FactoryBean implementation to generate.", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "Language to be used for javadoc comments. By default the system\'s default locale will be used.", 3 );
                append( sb, "", 0 );

                append( sb, "sourceRoot (Default: ${project.build.directory}/generated-sources/container)", 2 );
                append( sb, "Source root to create the factory bean class in.", 3 );
                append( sb, "", 0 );

                append( sb, "spacesPerIndentationLevel (Default: 4)", 2 );
                append( sb, "Number of spaces to use per indentation level.", 3 );
                append( sb, "", 0 );

                append( sb, "springDescriptor (Default: ${project.build.directory}/classes/META-INF/jdtaus/spring-beans.xml)", 2 );
                append( sb, "Name of the spring beans descriptor to generate.", 3 );
                append( sb, "", 0 );

                append( sb, "testClassPathElementsExcludeRegexp", 2 );
                append( sb, "A regular expression used for excluding elements from the test classpath elements. By default no elements will be excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "testMode (Default: false)", 2 );
                append( sb, "Flag indicating test mode. In test mode generated sources will be printed to the console and no files will be written.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "verify-jar".equals( goal ) )
        {
            append( sb, "jdtaus-container-mojo:verify-jar", 0 );
            append( sb, "Mojo to validate a set of modules from a single jar file.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classPathElementsExcludeRegexp", 2 );
                append( sb, "A regular expression used for excluding elements from the runtime classpath elements. By default no elements will be excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "encoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing sources. By default the system\'s default encoding will be used.", 3 );
                append( sb, "", 0 );

                append( sb, "jarFile (Default: ${project.build.directory}/${project.build.finalName}.jar)", 2 );
                append( sb, "(no description available)", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "Language to be used for javadoc comments. By default the system\'s default locale will be used.", 3 );
                append( sb, "", 0 );

                append( sb, "spacesPerIndentationLevel (Default: 4)", 2 );
                append( sb, "Number of spaces to use per indentation level.", 3 );
                append( sb, "", 0 );

                append( sb, "testClassPathElementsExcludeRegexp", 2 );
                append( sb, "A regular expression used for excluding elements from the test classpath elements. By default no elements will be excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "testMode (Default: false)", 2 );
                append( sb, "Flag indicating test mode. In test mode generated sources will be printed to the console and no files will be written.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "verify-model".equals( goal ) )
        {
            append( sb, "jdtaus-container-mojo:verify-model", 0 );
            append( sb, "Mojo to validate set of modules.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classPathElementsExcludeRegexp", 2 );
                append( sb, "A regular expression used for excluding elements from the runtime classpath elements. By default no elements will be excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "encoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing sources. By default the system\'s default encoding will be used.", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "Language to be used for javadoc comments. By default the system\'s default locale will be used.", 3 );
                append( sb, "", 0 );

                append( sb, "spacesPerIndentationLevel (Default: 4)", 2 );
                append( sb, "Number of spaces to use per indentation level.", 3 );
                append( sb, "", 0 );

                append( sb, "testClassPathElementsExcludeRegexp", 2 );
                append( sb, "A regular expression used for excluding elements from the test classpath elements. By default no elements will be excluded.", 3 );
                append( sb, "", 0 );

                append( sb, "testMode (Default: false)", 2 );
                append( sb, "Flag indicating test mode. In test mode generated sources will be printed to the console and no files will be written.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
